// Borland C++ Builder
// Copyright (c) 1995, 1998 by Borland International
// All rights reserved

// (DO NOT EDIT: machine generated header) 'VExcelExport.pas' rev: 3.00

#ifndef VExcelExportHPP
#define VExcelExportHPP
#include <VBaseExport.hpp>
#include <Graphics.hpp>
#include <Classes.hpp>
#include <Db.hpp>
#include <SysUtils.hpp>
#include <SysInit.hpp>
#include <System.hpp>

//-- user supplied -----------------------------------------------------------

namespace Vexcelexport
{
//-- type declarations -------------------------------------------------------
enum TCellBorder { cbLeft, cbRight, cbTop, cbBottom };

typedef Set<TCellBorder, cbLeft, cbBottom>  TCellBorders;

enum TExcelColor { eclDefault, eclBlack, eclRed, eclGreen, eclBlue, eclYellow, eclCyan, eclMagenta, 
	eclWhite };

class DELPHICLASS TExcelOptions;
class PASCALIMPLEMENTATION TExcelOptions : public Classes::TPersistent 
{
	typedef Classes::TPersistent inherited;
	
private:
	System::AnsiString FPageFooter;
	System::AnsiString FPageHeader;
	Graphics::TFont* FDefaultFont;
	Graphics::TFont* FRowHeaderFont;
	TExcelColor FRowHeaderFontColor;
	void __fastcall SetPageFooter(const System::AnsiString Value);
	void __fastcall SetPageHeader(const System::AnsiString Value);
	void __fastcall SetDefaultFont(const Graphics::TFont* Value);
	void __fastcall SetRowHeaderFont(const Graphics::TFont* Value);
	void __fastcall SetRowHeaderFontColor(TExcelColor Value);
	
public:
	__fastcall TExcelOptions(void);
	__fastcall virtual ~TExcelOptions(void);
	virtual void __fastcall Assign(Classes::TPersistent* Source);
	
__published:
	__property System::AnsiString PageHeader = {read=FPageHeader, write=SetPageHeader};
	__property System::AnsiString PageFooter = {read=FPageFooter, write=SetPageFooter};
	__property Graphics::TFont* DefaultFont = {read=FDefaultFont, write=SetDefaultFont};
	__property Graphics::TFont* RowHeaderFont = {read=FRowHeaderFont, write=SetRowHeaderFont};
	__property TExcelColor RowHeaderFontColor = {read=FRowHeaderFontColor, write=SetRowHeaderFontColor, 
		default=0};
};

typedef void __fastcall (__closure *TGetExcelCellParamsEvent)(System::TObject* Sender, Db::TField* Field
	, bool ColHeader, TCellBorders Borders);

class DELPHICLASS TVExcelExport;
class PASCALIMPLEMENTATION TVExcelExport : public Vbaseexport::TVExport 
{
	typedef Vbaseexport::TVExport inherited;
	
private:
	Classes::TFileStream* Stream;
	TExcelOptions* FExcelOptions;
	Classes::TStrings* FColumnsWidth;
	TGetExcelCellParamsEvent FOnGetExcelCellParams;
	void __fastcall SetColumnsWidth(const Classes::TStrings* Value);
	void __fastcall SetExcelOptions(const TExcelOptions* Value);
	
protected:
	__property ColumnsCaptions ;
	virtual void __fastcall Abort(void);
	void __fastcall GetExcelCellParams(Db::TField* Field, bool ColHeader, TCellBorders Borders);
	
public:
	__fastcall virtual TVExcelExport(Classes::TComponent* AOwner);
	__fastcall virtual ~TVExcelExport(void);
	virtual bool __fastcall Execute(void);
	
__published:
	__property TExcelOptions* ExcelOptions = {read=FExcelOptions, write=SetExcelOptions};
	__property Classes::TStrings* ColumnsWidth = {read=FColumnsWidth, write=SetColumnsWidth};
	__property FileName ;
	__property Dataset ;
	__property UserFormats ;
	__property Formats ;
	__property Captions ;
	__property ShowFile ;
	__property ColHeaders ;
	__property Header ;
	__property Footer ;
	__property OnRecordExported ;
	__property OnBeginExport ;
	__property OnEndExport ;
	__property OnStopExport ;
	__property OnGetExportText ;
};

//-- var, const, procedure ---------------------------------------------------
extern PACKAGE TExcelColor __fastcall ColorToExcelColor(Graphics::TColor AColor);
extern PACKAGE Graphics::TColor __fastcall ExcelColorToColor(TExcelColor AColor, Graphics::TColor DefColor
	);

}	/* namespace Vexcelexport */
#if !defined(NO_IMPLICIT_NAMESPACE_USE)
using namespace Vexcelexport;
#endif
//-- end unit ----------------------------------------------------------------
#endif	// VExcelExport
